function regress70s

chooseMARRIED = 0;
useLAG_DW     = 1;
includeAGE    = 0;
YEARdummy     = 0;
onlyAsInstr   = 1;    % use dummies only as instruments for dw?
useYEARS      = [1972 1973 1976 1980 1981];
sameFIRST     = 1;
chooseSRC     = 1;
report.first  = 1;    % Report results from first stage regressions?
report.second = 0;    % Report results from second stage regressions?


Y    = load('data70s_y.asc');
H    = load('data70s_h.asc');
WH   = load('data70s_w.asc');
EMP  = load('data70s_emp.asc');
MAR  = load('data70s_mar.asc');
MISC = load('data70s_misc.asc');
SAV  = load('data70s_sav.asc');
REL  = load('data70s_rel.asc');
SEQ  = load('data70s_seq.asc');
FAM  = load('data70s_fam.asc');
AGE  = load('data70s_age.asc');

cpi  = load('cpi.txt');

[nPers,nYears] = size(Y);

tmp  = -99*ones(nPers,1);
SAV  = [SAV(:,1:3) tmp tmp SAV(:,4) tmp tmp tmp SAV(:,5:6) tmp];

adjust72_83 = cpi(450,2);
cpi  = cpi([289:12:(289+12*11)],2);                             % cpi(1) = Jan 1970
adjust72_83 = adjust72_83 / cpi(3);
cpi  = ones(nPers,1)*cpi' / cpi(3);                             % Use 1972 prices

Y    = Y ./ cpi;
WH   = WH ./ cpi / 100;
clear cpi

prints('',0);
prints('==============================================',0)
prints('>>>>>    REGRESS 1970s, year by year     <<<<<',0)
prints(date,1); cl = clock;
prints(cl(4),2,0); prints(':'); prints(cl(5),2,0,0);
fprintf(1,'# Individuals in sample = %8i, # Years in sample = %8i\n',nPers,nYears);

ii     = find(max(H')>0);
fprintf(1,'Ever worked?                 Loss = %8i persons\n',nPers-length(ii));
nPers1 = length(ii);

jj     = find(sum((REL==1)')>0);
ii     = intersect(ii,jj);
fprintf(1,'Ever head?                   Loss = %8i persons\n',nPers1-length(ii));
nPers1 = length(ii);

if chooseSRC
jj     = find(MISC(ii,2)<5000)';                         
ii     = ii(jj);
fprintf(1,'SRC only                     Loss = %8i persons\n',nPers1-length(ii));
nPers1 = length(ii);
end


% Drop observations
Y      = Y(ii,:);
H      = H(ii,:);
WH     = WH(ii,:);
EMP    = EMP(ii,:);
MAR    = MAR(ii,:);
MISC   = MISC(ii,:);
SAV    = SAV(ii,:);
REL    = REL(ii,:);
SEQ    = SEQ(ii,:);
FAM    = FAM(ii,:);
AGE    = AGE(ii,:);


nPers = size(Y,1);
nObs  = nPers*nYears;
fprintf(1,'\n# Remaining individuals in sample = %8i, Remaining observations = %8i\n\n',nPers,nObs);

YEAR   = ones(nPers,1)*(1970:1981);

SRC    = MISC(:,2) < 5000;
SRC    = SRC*ones(1,nYears);

ii     = find(AGE>24 & AGE<61);                                 % age 25-60
age_ii = ii;
fprintf(1,'Age 25-60                   Loss = %8i observations\n',nObs-length(ii(:)));
nObs1  = length(ii);

jj     = find(REL==1);                                          % head
hd_ii  = jj;
ii     = intersect(ii,jj);
fprintf(1,'Head                        Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii);

if chooseMARRIED
jj     = find(MAR == 1 & FAM < 2 & FAM >=0);                    % married, stable household 
mar_ii = jj;
ii     = intersect(ii,jj);
fprintf(1,'Married & Same wife         Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii);
else
jj     = find(FAM < 2 & FAM >=0);                               % stable household 
mar_ii = jj;
ii     = intersect(ii,jj);
fprintf(1,'Stable household            Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii);
end

tmp    = [EMP(:,1:6) EMP(:,7:end)-1];                           % new definition in 1976!
jj     = find(tmp <= 2 & tmp >= 0);                             % in labor market?
ii     = intersect(ii,jj);
fprintf(1,'In labor market?            Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

ii     = intersect(find(H > 0),ii);                             % working?
fprintf(1,'H > 0?                      Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

jj     = find(ismember(YEAR,useYEARS));                         % remove years
ii     = intersect(ii,jj);
fprintf(1,'Remove years                Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

warning off MATLAB:divideByZero
dHRel  = [-ones(nPers,1) H(:,2:end)./H(:,1:end-1)];             % first column = dummy
dHAbs  = [100*ones(nPers,1) abs(H(:,2:end)-H(:,1:end-1))];      % first column = dummy
warning on MATLAB:divideByZero
jj     = find(H < 4860 & dHRel < 3.5 & dHRel > 0.4 & dHAbs < 3000);
ii     = intersect(ii,jj);                                      % H ok?
fprintf(1,'H < 4860 and dH ok?         Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

warning off MATLAB:divideByZero
W       = Y./H;
dWRel  = [-ones(nPers,1) W(:,2:end)./W(:,1:end-1)];             % first column = dummy
dWAbs  = [100*ones(nPers,1) abs(W(:,2:end)-W(:,1:end-1))];      % first column = dummy
warning on MATLAB:divideByZero
jj     = find(W > 0.40 & dWRel < 3.5 & dWRel > 0.4 & dWAbs < 13);
ii     = intersect(ii,jj);                                      % W ok?
fprintf(1,'W > 0.40 and dW ok?         Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

tmp    = [EMP(:,1:6) EMP(:,7:end)-1];
jj     = find(tmp <= 2 & H > 0 & H < 4860 & W > 0);             % Lags ok for W and H?
ii     = intersect(ii,jj+nPers);
ii     = intersect(ii,jj+2*nPers);
fprintf(1,'Lags ok for W and H?        Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

warning off MATLAB:divideByZero
dWRel = [-ones(nPers,1) W(:,2:end)./W(:,1:end-1)];           % first column = dummy
dWAbs = [100*ones(nPers,1) abs(W(:,2:end)-W(:,1:end-1))];    % first column = dummy
warning on MATLAB:divideByZero
jj     = find(dWRel < 3.5 & dWRel > 0.4 & dWAbs < 13);
ii     = intersect(ii,jj+nPers);                                % Lags ok for dW?
fprintf(1,'Lagged dW ok?              Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

jj     = intersect(mar_ii,hd_ii);                               % Lags ok for family and head?
ii     = intersect(ii,jj+nPers);
ii     = intersect(ii,hd_ii+2*nPers);
fprintf(1,'Lags ok for age and family? Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

ii     = intersect(ii,find(WH>0));                              % Paid by the hour?
fprintf(1,'Paid by the hour?           Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

warning off MATLAB:divideByZero
dWHRel = [-ones(nPers,1) WH(:,2:end)./WH(:,1:end-1)];           % first column = dummy
dWHAbs = [100*ones(nPers,1) abs(WH(:,2:end)-WH(:,1:end-1))];    % first column = dummy
warning on MATLAB:divideByZero
jj     = find(WH > 0.40 & dWHRel < 3.5 & dWHRel > 0.4 & dWHAbs < 13);
ii     = intersect(ii,jj);                                      % WH ok?
fprintf(1,'WH > 0.40 and dWH ok?       Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

jj     = find(WH > 0.40);
ii     = intersect(ii,jj+nPers);
ii     = intersect(ii,jj+2*nPers);
fprintf(1,'Lags ok for WH?             Loss = %8i observations\n',nObs1-length(ii(:)));

if useLAG_DW
jj     = find(dWHRel < 3.5 & dWHRel > 0.4 & dWHAbs < 13);
ii     = intersect(ii,jj+nPers);                                % Lags ok for dWH?
fprintf(1,'Lagged dWH ok?              Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));
end

jj     = find(SAV >= 0);                         
ii     = intersect(ii,jj+nPers);
fprintf(1,'Require savings info        Loss = %8i observations\n',nObs1-length(ii(:)));
nObs1  = length(ii(:));

fprintf(1,'\n# Remaining observations = %8i\n\n',length(ii));


Fstat99 = [6.63 4.61 3.78 3.32 3.02 2.80 2.64 2.51 2.41 2.32 2.25 2.18 2.13 2.09 2.04 2.01 1.98 1.95 1.91 1.88:-0.018:1.70];
Fstat95 = [3.84 3.00 2.60 2.37 2.21 2.10 2.01 1.94 1.88 1.83 1.79 1.75 1.72 1.69 1.67 1.65 1.63 1.61 1.59 1.57:-0.011:1.46];


Dw      = log(dWRel(ii));
Dh      = log(dHRel(ii));
Dww     = log(dWHRel(ii));
lag_Dww = log(dWHRel(ii-nPers));
lag_ww  = log(WH(ii-nPers)); 
AGE     = AGE(ii);
YEAR    = YEAR(ii);
SRC     = SRC(ii);
SAV     = SAV(ii-nPers);             % Note: savings observed in 1970 used to explain 1971 dh (i.e. h(1970) - h(1969)), etc
n       = length(ii);

Y       = Y(ii);
EMP     = EMP(ii);
MAR     = MAR(ii);



% ====================================================
% Regressions
%
% Let Y  = dependent variable
%     X1 = exogenous explanatory
%     X2 = endogenous explanatory
%     X  = [X1 X2]
%     Z0 = instruments for X2
%     Z  = instruments for X 
% ====================================================

Y       = Dh;
X1      = ones(n,1);
X2      = Dw;

if useLAG_DW
  Z0    = [lag_Dww lag_ww];
else
  Z0    = [Dww];
end

EXTRA_VARS = [];
if includeAGE, EXTRA_VARS = [EXTRA_VARS AGE AGE.^2]; end
if YEARdummy
    for i = 1:(length(useYEARS)-1)
        EXTRA_VARS = [EXTRA_VARS YEAR==useYEARS(i)];
    end
end

if onlyAsInstr
    Z0  = [Z0 EXTRA_VARS];
else
    X1  = [X1 EXTRA_VARS];
end

report.title = '>>> All included <<<\n';
Ret(1) = tsls(Y,X1,X2,Z0,[],report);
if sameFIRST
  Xhat = Ret(1).Xhat;
  report.first = 0;
end

old_ii = ii;
nObs   = n;

ii     = find(SAV==1);                         
report.title = '>>> Has savings? <<<\n';
if sameFIRST, Ret(2) = tsls(Y(ii),X1(ii,:),X2(ii,:),Z0(ii,:),Xhat(ii,:),report);
else Ret(2) = tsls(Y(ii),X1(ii,:),X2(ii,:),Z0(ii,:),[],report); end



fprintf(1,'\n======================================================\n');
fprintf(1,'>>>>>             REGRESS 1970''s                 <<<<<\n')
fprintf(1,'                    %s ',date); cl = clock;
fprintf(1,'%2d:%2d\n',cl(4:5));
fprintf(1,'MARRIED  = %6d   ',chooseMARRIED);
fprintf(1,'SAME 1st = %6d\n',sameFIRST);
for i=1:length(useYEARS)
    fprintf(1,'#obs %4d = %6d\n',useYEARS(i),sum(YEAR==useYEARS(i)));
end
fprintf(1,'\n=========================\n');
fprintf(1,'           no       A>0\n');
fprintf(1,'-------------------------\n');
if sameFIRST
fprintf(1,'R2(1st) %6.2f\n',Ret(1).FstR2);
fprintf(1,'F(1st)  %6.2f\n',Ret(1).FstF);
fprintf(1,'Sig(1st)%6s\n',Ret(1).FstSig);
else
fprintf(1,'R2(1st) %6.2f   %6.2f\n',[Ret.FstR2]);
fprintf(1,'F(1st)  %6.2f   %6.2f\n',[Ret.FstF]);
fprintf(1,'Sig(1st)%6s   %6s\n',Ret(:).FstSig);
end
fprintf(1,'-------------------------\n');
fprintf(1,'const   %6.2f   %6.2f\n',[Ret.const]);
fprintf(1,'         (%4.2f)   (%4.2f)\n',...
        [Ret.const_std]);
fprintf(1,'dw      %6.2f   %6.2f\n',[Ret.dw]);
fprintf(1,'         (%4.2f)   (%4.2f)\n',...
        [Ret.dw_std]);
fprintf(1,'-------------------------\n');
fprintf(1,'R2      %6.2f   %6.2f\n',[Ret.R2]);
fprintf(1,'F       %6.2f   %6.2f\n',[Ret.F]);
fprintf(1,'Sig     %6s   %6s\n',Ret(:).sig);
fprintf(1,'n       %6d   %6d\n',[Ret.n]);








% ====================================================================================
% FUNCTION tsls
%
% Two stage least squares
%
%     Y      = dependent variable
%     X1     = exogenous explanatory
%     X2     = endogenous explanatory
%     Z0     = instruments for X2
%     XHAT   = empty or instruments calculated in larger sample
%     report = struct used to transport information
%
% ====================================================================================
function ret = tsls(Y,X1,X2,Z0,Xhat,report)

Fstat99 = [6.63 4.61 3.78 3.32 3.02 2.80 2.64 2.51 2.41 2.32 2.25 2.18 2.13 2.09 2.04 2.01 1.98 1.95 1.91 1.88:-0.018:1.70];
Fstat95 = [3.84 3.00 2.60 2.37 2.21 2.10 2.01 1.94 1.88 1.83 1.79 1.75 1.72 1.69 1.67 1.65 1.63 1.61 1.59 1.57:-0.011:1.46];

X = [X1 X2];
if isempty(Xhat)
    Z    = [X1 Z0];
else
    Z    = Xhat;
end
T = size(Y,1);
k = size(X,2);

bz   = inv(Z'*Z)*Z'*X;
Xhat = Z*bz;


% Second stage
b    = inv(Xhat'*X)*Xhat'*Y;
u    = Y - X*b;

Yhat = Xhat*b;
SSE  = (u-mean(u))'*(u-mean(u));
SSR  = (Yhat-mean(Yhat))'*(Yhat-mean(Yhat));

s2   = SSE /(T-k);
S    = s2*inv(Xhat'*X);
stdb = sqrt(diag(S));

if report.second
fprintf(1,'==============================================\n')
if isfield(report,'title'), fprintf(1,report.title), end
end

n = size(X2,2);
for i = 1:n
    if report.first
    fprintf(1,'First stage regression:\n')
    if n>1, fprintf(1,'Endogenous variable #%2d\n',i); end
    end
    y1 = X2(:,i);
    b1 = inv(Z'*Z)*Z'*y1;
    e1 = y1 - Z*b1;
    k1 = size(Z,2);
    ss = sum(e1.^2)/(T-k1);
    SS = ss*inv(Z'*Z);
    stdb1 = sqrt(diag(SS));
    rr = 1 - e1'*e1 / ((y1-mean(y1))'*(y1-mean(y1)));
    ff = (rr/(k1-1)) / ((1-rr)/(T-k1));
    if ff > Fstat99(k1-1), sig = '**';
    elseif ff > Fstat95(k1-1), sig = '* '; else sig = '  '; end;
    if report.first
    fprintf(1,'R2 = %8.3f   ',rr);
    fprintf(1,'F  = %7.2f ',ff), fprintf(1,'%2s\n',sig);
    fprintf(1,'%12.6f   (%10.6f)\n',[b1,stdb1]');
    fprintf(1,'----------------------------------------------\n')
    end
    ret.FstSig = sig;
end

r2    = 1 - u'*u / ((Y-mean(Y))'*(Y-mean(Y)));                       % As reported by EViews
r2    = SSR / (SSR+SSE);                                             % As reported by SAS and SPSS. Fstat should be based ...
fstat = (r2/(k-1)) / ((1-r2)/(T-k));                                 % ... on this r2
if fstat > Fstat99(k-1), sig = '**';
elseif fstat > Fstat95(k-1), sig = '* '; else sig = '  '; end;
if report.second
fprintf(1,'R2 = %8.3f\n',r2);                                          
fprintf(1,'F  = %6.2f ',fstat), fprintf(1,'%2s   ',sig);
fprintf(1,'n = %6d\n',T);
fprintf(1,'%12.6f   (%10.6f)\n',[b stdb]');
end

ret.const = b(1);
ret.const_std = stdb(1);
ret.dw    = b(end);
ret.dw_std    = stdb(end);
ret.R2    = r2;
ret.F     = fstat;
ret.n     = T;
ret.sig   = sig;
ret.FstR2 = rr;
ret.FstF  = ff;
ret.Xhat  = Xhat;